#
# Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
# All rights reserved.
# This component and the accompanying materials are made available
# under the terms of "Eclipse Public License v1.0"
# which accompanies this distribution, and is available
# at the URL "http://www.eclipse.org/legal/epl-v10.html".
#
# Initial Contributors:
# Nokia Corporation - initial contribution.
#
# Contributors:
#
# Description:
# XML-configuration file base class
#

import os#, libxml2

# TODO: What to do about validation
class XMLConfigFile(object):
    '''
    Validate the config against schema, read and write.
    '''
##    class Error(Exception):
##        '''
##
##        '''

##    schema = ""
##    def isValid(cls, xmlString):
##        '''
##        Validate XML against schema
##        '''
##        ctxt = libxml2.schemaNewParserCtxt(cls.schema)
##        validationCtxt = ctxt.schemaParse().schemaNewValidCtxt()
##        try:
##            doc = libxml2.parseMemory(xmlString, len(xmlString))
##            if validationCtxt.schemaValidateDoc(doc) == 0:
##                return True
##        except:
##            pass
##        return False
##
##    isValid = classmethod(isValid)

    def __init__(self, XMLConfigurationFilePath):
        self.XMLConfigurationFilePath = XMLConfigurationFilePath
        if os.path.isfile(self.XMLConfigurationFilePath):
            self.read()
        else:
            self.write()

    def read(self, file=None):
        '''
        Read from file
        '''
        if not file:
            file = self.XMLConfigurationFilePath
        f = open(file)
        xmlString = f.read()
        f.close()
        # Disabled temporarily to get working on python environment without libxml2
##        if not self.__class__.isValid(xmlString):
##            raise ValueError, "Configuration file is not valid. See %s."%self.__class__.schema
        self.fromXMLString(xmlString)

    def write(self):
        '''
        Write to path
        '''
        xmlString = self.toXMLString()
        # Disabled temporarily to get working on python environment without libxml2
##        if self.__class__.isValid(xmlString):
        f = open(self.XMLConfigurationFilePath, "w")
        f.write(xmlString)
        f.close()
##        else:
##            raise __class__.Error, "Failed to create valid XML from inputs."

    def fromXMLString(self): # pragma: no cover
        raise NotImplementedError

    def toXMLString(self): # pragma: no cover
        raise NotImplementedError